/* global pieregister, pieregisterRecaptchaLoad, grecaptcha */

'use strict';

var PieRgisterElementorFrontend = window.PieRgisterElementorFrontend || ( function( document, window, $ ) {

	var vars = {};
	var i = 0;

	/**
	 * Public functions and properties.
	 *
	 * @type {object}
	 */
	var app = {

		/**
		 * Start the engine.
		 */
		init: function() {

			app.events();
		},

		/**
		 * Register JS events.
		 */
		events: function() {
			
			$( window ).on( 'elementor/frontend/init', function( event, id, instance ) {

				// Widget frontend events.
				elementorFrontend.hooks.addAction( 'frontend/element_ready/PieRegister.default', app.widgetPreviewEvents );
				
			} );
		},

		widgetPreviewEvents: function( $scope ) {

			$scope.each(function(){
				var $form_ids = pie_pr_dec_vars.prRegFormsIds;
				var $hform_ids = pie_pr_dec_vars.prReghFormsIds;
				var $reCaptcha_public_key = pie_pr_dec_vars.reCaptcha_public_key;
				var $reCaptcha_language = pie_pr_dec_vars.reCaptcha_language;
				var $hCaptcha_public_key = pie_pr_dec_vars.hCaptcha_public_key;
				var $hCaptcha_language = pie_pr_dec_vars.hCaptcha_language;
	
				// reCAPTCHA
				for(i=0;i<=$form_ids.length;i++){
					var $_reg_form_id;
					$_reg_form_id = $scope.find('#'+$form_ids[i]);
					if($_reg_form_id != null && $_reg_form_id.length != 0 && $_reg_form_id.find(".piereg_recaptcha_reg_div")) {
						$regforms[i] = grecaptcha.render($form_ids[i], {
							"sitekey" : $reCaptcha_public_key,
							'theme' : pie_pr_dec_vars.reg_forms_theme[$form_ids[i]],
							  'hl' : $reCaptcha_language
						});
					}
				}

				// hCaptcha
				for(i=0;i<=$hform_ids.length;i++){
					var $_reg_form_id;
					$_reg_form_id = $scope.find('#'+$hform_ids[i]);
					if($_reg_form_id != null && $_reg_form_id.length != 0 && $_reg_form_id.find(".piereg_hcaptcha_reg_div")) {
						$regforms[i] = hcaptcha.render($hform_ids[i], {
							"sitekey" : $hCaptcha_public_key,
							'theme' : 'light',
							  'hl' : $hCaptcha_language
						});
					}
				}

				var $_not_widget;
				$_not_widget = $scope.find("#not_widget");

				if($_not_widget != null && $_not_widget.length != 0 && $_not_widget.find("piereg_hcaptcha_widget_div")) {
					not_widget = hcaptcha.render("not_widget", {
					"sitekey" : $hCaptcha_public_key,
					'theme'   : 'light',
					'hl'      : $hCaptcha_language
					});
				}
				var $_is_widget;
				$_is_widget = $scope.find("#is_widget");
				if($_is_widget != null && $_is_widget.length != 0&& $_is_widget.find("piereg_hcaptcha_widget_div")) {
					is_widget = hcaptcha.render("is_widget", {
					"sitekey" : $hCaptcha_public_key,
					'theme'   : 'light',
					'hl'      : $hCaptcha_language
					});
				}
				var $_not_forgot_widget;
				$_not_forgot_widget = $scope.find("#not_forgot_widget");
				if($_not_forgot_widget != null && $_not_forgot_widget.length != 0 && $_not_forgot_widget.find("piereg_hcaptcha_widget_div")) {
					not_widget = hcaptcha.render("not_forgot_widget", {
					"sitekey" : $hCaptcha_public_key,
					'theme'   : 'light',
					'hl'      : $hCaptcha_language
					});
				}
				var $_is_forgot_widget;
				$_is_forgot_widget = $scope.find("#is_forgot_widget");

				if($_is_forgot_widget != null && $_is_forgot_widget.length != 0 && $_is_forgot_widget.find("piereg_hcaptcha_widget_div")) {
					is_widget = hcaptcha.render("is_forgot_widget", {
					"sitekey" : $hCaptcha_public_key,
					'theme'   : 'light',
					'hl'      : $hCaptcha_language
					});
				}
			});
				
		},
	};

	return app;

}( document, window, jQuery ) );

// Initialize.
PieRgisterElementorFrontend.init();